
public abstract class Element {
	protected int posX;
	protected int posY;
	protected int hp;
	protected int state;
	protected int size;
	
	public static int getDistance(Element a, Element b){
		int d = (Math.abs(a.getX() - b.getX()));
		return d - ((a.getSize() + b.getSize())/ 2);
	}
	
	public boolean isDead(){
		return hp > 0 ? false : true;
	}
	
	public boolean isAlive(){
		return !(this.isDead());
	}
	
	/// GETTERS
	
	public int getX(){
		return posX;
	}
	
	public int getY(){
		return posY;
	}
	
	public int getHp(){
		return hp;
	}
	
	public int getState(){
		return state;
	}
	
	public int getSize(){
		return size;
	}
	
	/// SETTERS
	
	public void setX(int x){
		posX = x;
	}
	
	public void setY(int y){
		posY = y;
	}
	
	public void setHp(int hp){
		this.hp = hp;
	}
	
	public void setState(int s){
		state = s;
	}
	
	public void setSize(int s){
		size = s;
	}
}
